unit ObjWordMagic;

{                            -=< Word Magic Demonstration Program >=-
{
{ Copyright SoftSpot Software 2000 - All Rights Reserved
{
{ Author        : Andrew J Jameson
{
{ Creation Date : 20 August 1999
{
{ Version       : 1.00
{
{ Last Revision :
{
{ Revision      : 1.00
{
{ Description   :
{
{                 This is a test program that demonstrates/illustrates the core functionality of the
{                 Word Magic Lexicon components.  In most of the cases, the operations are timed to
{                 provide a good idea of the performance capabilities of Word Magic.  (The timing is
{                 dependent on the type of CPU and does require an RDTSC compliant processor - a
{                 Pentium.)
{
{                 It is hoped that this program does clearly illustrate the capabilities of Word
{                 Magic and that it provides a good reference to enable the production of new
{                 Word Magic based applications.
{
{                 We are keen to receive any form of comments/queries and even criticisms - so if
{                 you are experiencing a problem please contact us at :
{
{                                   softspot.com@cableinet.co.uk
{
{ Modifications :                                                                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus,

  ObjLexicon,
  ObjLexiconTools,
  ObjLexiconFileTools,
  ObjLexiconAnagram,
  ObjLexiconGameLine,
  ObjWordMagicAbout;

type
  TfrmWordMagic = class(TForm)
    Lexicon           : TLexicon;  
    LexiconTools      : TLexiconTools;
    LexiconFileTools  : TLexiconFileTools;
    LexiconAnagram    : TLexiconAnagram;
    LexiconGameLine   : TLexiconGameLine;

    MainMenu          : TMainMenu;
    Timer             : TTimer;
    mnuFile           : TMenuItem;
      mnuOpen         : TMenuItem;
      N1              : TMenuItem;
      mnuExit         : TMenuItem;
    mnuHelp           : TMenuItem;
      mnuContents     : TMenuItem;
      N2              : TMenuItem;
      mnuAbout        : TMenuItem;
    sbForm1           : TStatusBar;
    sbForm2           : TStatusBar;
    PageControl1      : TPageControl;
      TabSheet1       : TTabSheet;
      TabSheet2       : TTabSheet;
      TabSheet3       : TTabSheet;
      PageControl2    : TPageControl;
        TabSheet4     : TTabSheet;
        TabSheet5     : TTabSheet;
      TabSheet6       : TTabSheet;
    sbPage1           : TStatusBar;
    lbWordsFound      : TListBox;
    lbInitialLetters  : TListBox;
    lbWordLength      : TListBox;
    edAnagram         : TEdit;
    pnNoItems         : TPanel;
    pnTotalCount      : TPanel;
    pnAnagramNoChars  : TPanel;
    udAnagramNoChars  : TUpDown;
    lbTotal1          : TLabel;
    lbTotal2          : TLabel;

    lbPage2Title      : TLabel;
    sbPage2           : TStatusBar;
    pbCompress        : TProgressBar;
    lbCompTitle       : TLabel;
    edLexTitle        : TEdit;
    lbCompCopyright   : TLabel;
    edLexCopyright    : TEdit;
    pnCompress        : TPanel;
    lbCompress0       : TLabel;
    lbTotWordCount    : TLabel;
    lbCompress1       : TLabel;
    lbLexWordCount    : TLabel;
    lbCompress2       : TLabel;
    lbErrDupWCount    : TLabel;
    lbCompress3       : TLabel;
    lbErrCharCount    : TLabel;
    lbCompress4       : TLabel;
    lbErrLengCount    : TLabel;
    lbCompMin         : TLabel;
    pnCompressMin     : TPanel;
    cbCompressCase    : TComboBox;
    udCompressMin     : TUpDown;
    lbCompMax         : TLabel;
    pnCompressMax     : TPanel;
    udCompressMax     : TUpDown;
    btExpand          : TButton;
    btCompress        : TButton;
    lbCompLog         : TLabel;
    cbLog             : TCheckBox;

    lbPage3Title      : TLabel;
    sbPage3           : TStatusBar;
    lbFind            : TLabel;
    lbFindResult      : TLabel;
    edFind            : TEdit;
    btFind            : TButton;
    btAddWord         : TButton;
    btDeleteWord      : TButton;
    pnFindResult      : TPanel;
    btRandom          : TButton;
    pnRandom          : TPanel;
    lbPartial         : TLabel;
    lbPartialResult   : TLabel;
    edPartial         : TEdit;
    pnPartial         : TPanel;
    lbExpand          : TLabel;
    btExpandMem       : TButton;

    sbPage4           : TStatusBar;
    lbMonkeyTitle     : TLabel;
    imMonkey          : TImage;
    lbMonkey          : TListBox;
    btMonkey          : TButton;
    btReadAll         : TButton;
    lbLexLineWords    : TListBox;
    edLexLine         : TEdit;
    edLexChars        : TEdit;

    procedure   UpdateCompressPercent (Percent : integer);

    procedure   mnuOpenClick          (Sender : TObject);
    procedure   mnuExitClick          (Sender : TObject);
    procedure   mnuContentsClick      (Sender : TObject);
    procedure   mnuAboutClick         (Sender : TObject);

    procedure   lbInitialLettersClick (Sender : TObject);
    procedure   lbWordLengthClick     (Sender : TObject);
    procedure   edAnagramChange       (Sender : TObject);
    procedure   edAnagramKeyPress     (Sender : TObject; var Key : Char);
    procedure   udAnagramNoCharClick  (Sender : TObject; Button : TUDBtnType);
    procedure   lbWordsFoundDblClick  (Sender : TObject);
    procedure   edAnagramDblClick     (Sender : TObject);

    procedure   btCompressClick       (Sender : TObject);
    procedure   btExpandClick         (Sender : TObject);
    procedure   udCompressMinClick    (Sender : TObject; Button : TUDBtnType);
    procedure   udCompressMaxClick    (Sender : TObject; Button : TUDBtnType);

    procedure   btFindClick           (Sender : TObject);
    procedure   btAddWordClick        (Sender : TObject);
    procedure   btDeleteWordClick     (Sender : TObject);
    procedure   btRandomClick         (Sender : TObject);
    procedure   edPartialChange       (Sender : TObject);
    procedure   btExpandMemClick      (Sender : TObject);

    procedure   btMonkeyClick         (Sender : TObject);
    procedure   btReadAllClick        (Sender : TObject);
    procedure   edLexFitLineChange    (Sender : TObject);
    procedure   TimerExpired          (Sender : TObject);
  private
    ListIsAnagram : boolean;
    procedure   DisplayMessage        (StatusBar : TStatusBar; TextMessage : shortstring);
    procedure   DisplayStatistics;
  public
    constructor Create                (AOwner : TComponent);  override;
    destructor  Destroy;                                      override;
    procedure	  DisplayHint           (Sender : TObject);
  end;

var
  frmWordMagic  : TfrmWordMagic;

implementation

{$R *.DFM}

var
  ExePath                 : string;
  StartCycles, EndCycles  : comp;
  CPUClockFrequency       : extended;

type
  TLexCycles = record
    Lo, Hi  : DWord;
  end;

{--------------------------------------------------------------------------------------------------}
{                                      RDTSC PENTIUM TIMING                                        }
{--------------------------------------------------------------------------------------------------}

function  CPUID : DWord; assembler;                                                                 {Test if this CPU supports RDTSC          }
asm
  push  ebx                                                                                         {Push the registers.                      }
  push  edi
  mov   eax, 1                                                                                      {Set opcodes for CPUID.                   }
  DW    $A20F
  mov   @Result, edx                                                                                {Get CPUID bits.                          }
  pop   edi
  pop   ebx                                                                                         {Pop the registers - done.                }
end; {CPUID}

{--------------------------------------------------------------------------------------------------}

procedure StartCount; assembler;
asm
  DW  $310F                                                                                         {Set opcode to get CPU timing cycles.     }
	mov TLexCycles(StartCycles).Hi, edx                                                               {Get number of cycles.                    }
	mov TLexCycles(StartCycles).Lo, eax
end; {StartCount}

{--------------------------------------------------------------------------------------------------}

procedure EndCount; assembler;
asm
  DW  $310F
	mov TLexCycles(EndCycles).Hi, edx                                                                 {Set opcode to get CPU timing cycles.     }
	mov TLexCycles(EndCycles).Lo, eax                                                                 {Get number of cycles.                    }
end; {EndCount}

{--------------------------------------------------------------------------------------------------}

procedure StartTime;
begin
  if ((CPUID and 16) = 16) then                                                                     {If CPU supports RDTSC then get the start }
    StartCount;                                                                                     {cycle count.                             }
end; {StartTime}

{--------------------------------------------------------------------------------------------------}

procedure EndTime;
begin
  if ((CPUID and 16) = 16) then                                                                     {If CPU supports RDTSC then get the end   }
    EndCount;                                                                                       {cycle count.                             }
end; {EndTime}

{--------------------------------------------------------------------------------------------------}

procedure GetCPUClockFrequency;                                                                     {Measure the CPU clock frequency.         }
var
  Tick : DWord;
begin
  Tick  := GetTickCount;                                                                            {We're going to count CPU clock cycles    }
  while Tick = GetTickCount do;                                                                     {over a 2 second interval.                }
  StartTime;
  while (GetTickCount < (Tick + 2000)) do;
  EndTime;
  CPUclockFrequency := (EndCycles-StartCycles)*0.5e-6; {MHz}                                        {Calculate the CPU frequency.             }
end; {GetCPUClockFrequency}

{--------------------------------------------------------------------------------------------------}

function  TimeElapsed(const NoLoops : integer) : shortstring;                                       {General timing text string routine.      }
var
  ElapsedTime : double;
begin
  if ((CPUID and 16) <> 16) then                                                                    {If CPU can't process timing then tell    }
    Result  := 'CPU does not support RDTSC timing operation'                                        {the user, otherwise ...                  }
  else begin
    ElapsedTime := (EndCycles-StartCycles)/CPUClockFrequency;                                       {Calculate the elapsed time for the test. }
    if (NoLoops > 0) then begin                                                                     {Some tests may involve many loops for    }
      ElapsedTime := ElapsedTime/NoLoops;                                                           {more accurate measurement. So convert to }
      if (ElapsedTime > 10000) then                                                                 {time per loop.  Define and adjust if we  }
        Result  := IntToStr(Round(ElapsedTime/1000))+' milliSecs'                                   {are going to use time in milliSecs or    }
      else                                                                                          {microSecs.                               }
        Result  := IntToStr(Round(ElapsedTime))+' microSecs';
      if (NoLoops > 1) then                                                                         {If there was more than a single loop,    }
        Result  := Result + ' (' + IntToStr(NoLoops) + ' loops)';                                   {tell the user how many were averaged.    }
    end else                                                                                        {For negative NoLoops - special case.     }
      Result  := IntToStr(Round(ElapsedTime/1000))+' milliSecs - ' +                                {Signifies that we're also going to work  }
                    IntToStr(Round(-NoLoops*1000000.0/ElapsedTime)) + ' words per second';          {out words per second too.                }
  end; {if}
end; {TimeElapsed}

{--------------------------------------------------------------------------------------------------}

constructor TfrmWordMagic.Create(AOwner : TComponent);
begin
  inherited;
  ListIsAnagram             := false;                                                               {Clear anagram list box flag.             }
  cbCompressCase.ItemIndex  := lxCaseNormal;                                                        {Set compress case to normal.             }
  ExePath                   := ExtractFilePath(Application.ExeName);                                {Get the execution path.                  }
  Application.HelpFile 	    := ExePath + 'Lexicon.hlp';                                             {Define the help file.                    }
  Lexicon.LexCharSet        := ['A'..'Z', 'a'..'z'];                                                {Define the valid character set.          }
  Lexicon.LexFileName       := ExePath + 'Demo.lex';                                                {Load the default lexicon.                }
  edLexTitle.Text           := Lexicon.LexTitle;                                                    {Display the lexicon title string and the }
  edLexCopyright.Text       := Lexicon.LexCopyright;                                                {copyright information.                   }
  LexiconTools.LexWordGetList(Lexicon.LexInitialLetters[1], 0, 0);                                  {Get all the words the first initial      }
  try                                                                                               {letter words into LexWordList and copy   }
    lbWordsFound.Items.Assign(LexiconTools.LexWordList);                                            {as many as possible into the display     }
  except                                                                                            {list box.                                }
  end; {try}
  pnNoItems.Caption         := IntToStr(LexiconTools.LexWordList.Count);                            {Tell us how many words start with the    }
  DisplayStatistics;                                                                                {the first initial letter.                }
  with Lexicon do                                                                                   {Get the lexicon statistics.              }
    sbForm1.Panels[0].Text  := ' ' + LexTitle + ' - ' + LexCopyright;                               {Display the lexicon title and copyright. }
  GetCPUClockFrequency;                                                                             {Finally get the CPU speed.               }
end; {constructor}

{--------------------------------------------------------------------------------------------------}

destructor TfrmWordMagic.Destroy;
begin
  inherited;
end; {destructor}

{--------------------------------------------------------------------------------------------------}

procedure	TfrmWordMagic.DisplayHint(Sender : TObject);                                              {Display hint text in the status bar.     }
begin
  sbForm2.Panels[0].Text := ' ' + Application.Hint;
end; {DisplayHint}

{--------------------------------------------------------------------------------------------------}
{                                       MENU METHODS                                               }
{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.mnuOpenClick(Sender : TObject);                                             {Open lexicon file menu.                  }
var
  OpenDialog  : TOpenDialog;
begin
  OpenDialog  := TOpenDialog.Create(Self);                                                          {Set up the open file dialog parameters.  }
  with OpenDialog do begin
    Filter  := 'Lexicon files (*.lex)|*.lex';
    Options := [ofFileMustExist, ofReadOnly, ofHideReadOnly];
    Title   := 'Select Lexicon File';
  end; {with}
  try
    if OpenDialog.Execute then begin                                                                {Get lexicon file name.                   }
      Screen.Cursor       := crHourGlass;                                                           {Might take a bit to load.                }
      Update;                                                                                       {Tidy up the screen before we start.      }
      StartTime;                                                                                    {We're going to time this operation.      }
      Lexicon.LexFileName := OpenDialog.FileName;                                                   {Load the lexicon.                        }
      EndTime;                                                                                      {Done - so stop timing.                   }
      edLexTitle.Text     := Lexicon.LexTitle;                                                      {Display lexicon title and copyright.     }
      edLexCopyright.Text := Lexicon.LexCopyright;
      ListIsAnagram       := false;                                                                 {Clear anagram list box flag.             }
      DisplayMessage(sbPage1, TimeElapsed(1));                                                      {Tell us how long it all took.            }
      LexiconTools.LexWordGetList(Lexicon.LexInitialLetters[1], 0, 0);                              {Get all the words the first initial      }
      try                                                                                           {letter words into LexWordList and copy   }
        lbWordsFound.Items.Assign(LexiconTools.LexWordList);                                        {as many as possible into the display     }
      except                                                                                        {list box.                                }
      end; {try}
      pnNoItems.Caption   := IntToStr(LexiconTools.LexWordList.Count);                              {Tell us how many words start with the    }
      DisplayStatistics;                                                                            {the first initial letter.                }
      with Lexicon do                                                                               {Get the lexicon statistics.              }
        sbForm1.Panels[0].Text  := ' ' + LexTitle + ' - ' + LexCopyright;                           {Display the lexicon title and copyright. }
    end; {if}
  finally
    Screen.Cursor   := crDefault;                                                                   {All done - restore the cursor to normal. }
    OpenDialog.Free;                                                                                {Get rid of the open file dialog.         }
  end; {try}
end; {mnuOpenClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.mnuExitClick(Sender : TObject);                                             {Surely you don't want to exit this       }
begin                                                                                               {application - but OK let's close for     }
  Close;                                                                                            {now.                                     }
end; {mnuExitClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.mnuContentsClick(Sender : TObject);                                         {Let's have a quick look at the help      }
begin                                                                                               {file - note I'm going to give you the    }
  Application.HelpCommand(HELP_FINDER, 0);                                                          {help tabbed contents/index page.         }
end; {mnuContentsClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.mnuAboutClick(Sender : TObject);                                            {Oh no, you want to see the About screen  }
begin                                                                                               { - not much to see really but there's    }
	with TfrmAboutWordMagic.Create(Application) do                                                    {some handy hints and tips here.          }
		try
      lbCPUMHz.Caption  := IntToStr(Round(CPUClockFrequency)) + ' MHz';                             {Pass in the CPU speed for display.       }
			ShowModal;                                                                                    {Go on, let's see the About screen.       }
		finally
			Update;                                                                                       {Tidy the screen as quickly s we can and  }
			Free;                                                                                         {destroy the About module - told you that }
		end; {try}                                                                                      {there wasn't much to see.                }
end; {mnuAboutClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.DisplayMessage(StatusBar : TStatusBar; TextMessage : shortstring);          {Display text messages in the status bar  }
begin                                                                                               {but only for three seconds - the timer   }
  Timer.Enabled             := false;                                                               {event cleans them up.                    }
  StatusBar.Panels[0].Text  := ' ' + TextMessage;
  Timer.Enabled             := true;
end; {DisplayMessage}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.TimerExpired(Sender : TObject);                                             {Just told you that the timer cleans up   }
begin                                                                                               {the display messages in all of the       }
  Timer.Enabled           := false;                                                                 {bars.  Note, we only clean up until next }
  sbPage1.Panels[0].Text  := '';                                                                    {time, so stop the timer.                 }
  sbPage2.Panels[0].Text  := '';
  sbPage3.Panels[0].Text  := '';
  sbPage4.Panels[0].Text  := '';
end; {TimerExpired}

{--------------------------------------------------------------------------------------------------}
{                                      EXAMPLE1 PAGE                                               }
{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.lbInitialLettersClick(Sender : TObject);                                    {Update word list box with new initial    }
var                                                                                                 {letters.                                 }
  LexWord : shortstring;
begin
  Screen.Cursor := crHourGlass;                                                                     {Might take some time - so change the     }
  ListIsAnagram := false;                                                                           {cursor and this isn't an anagram either. }
  with LexiconTools, lbInitialLetters do begin                                                      {Going to use the LexiconTools and the    }
    LexWord := Items[ItemIndex];                                                                    {intial letters list box.                 }
    StartTime;                                                                                      {We're going to time this operation.      }
    LexWordGetList(LexWord[1], 0, 0);                                                               {Get all words with the chosen initial    }
    EndTime;                                                                                        {letter - done now, so stop counting.     }
    DisplayMessage(sbPage1, TimeElapsed(1));                                                        {Go on, tell us how long it took.         }
    try                                                                                             {All the words we've got might not fit    }
      lbWordsFound.Items.Assign(LexWordList);                                                       {in our list box - just stuff in as many  }
    except                                                                                          {as possible.                             }
    end; {try}
    pnNoItems.Caption  := IntToStr(LexWordList.Count);                                              {Tell us how many words we got.           }
  end; {with}
  Screen.Cursor := crDefault;                                                                       {It's all over some restore normal cursor.}
end; {lbInitialLettersClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.lbWordLengthClick(Sender : TObject);                                        {Update wordlist box with all words of    }
var                                                                                                 {the length that we've chosen.            }
  LexWord : shortstring;
begin
  Screen.Cursor := crHourGlass;                                                                     {Might take a moment - so change the      }
  ListIsAnagram := false;                                                                           {cursor and this inn't an anagram either. }
  with LexiconTools, lbWordLength do begin                                                          {Going to use LexiconTools and the word   }
    LexWord     := Items[ItemIndex];                                                                {length list box.                         }
    LexWord[0]  := #2;                                                                              {Get the text from the length list box and}
    StartTime;                                                                                      {truncate it to leave only its the length.}
    LexWordGetList(LexWildChar, StrToInt(LexWord), StrToInt(LexWord));                              {Get the start time and go and get all of }
    EndTime;                                                                                        {words.  Done, so get the end count.      }
    DisplayMessage(sbPage1, TimeElapsed(1));                                                        {Tell us how long it took.                }
    try                                                                                             {Now, shift all the words into our display}
      lbWordsFound.Items.Assign(LexWordList);                                                       {List box - but ... they might not all    }
    except                                                                                          {fit - so do what we can.                 }
    end; {try}
    pnNoItems.Caption  := IntToStr(LexWordList.Count);                                              {Tell us how many words we got.           }
  end; {with}
  Screen.Cursor := crDefault;                                                                       {All over - so put the cursor back to     }
end; {lbWordLengthClick}                                                                            {normal.                                  }

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.edAnagramChange(Sender : TObject);
var
  lp1     : integer;
  LexWord : shortstring;
begin
  with LexiconAnagram, lbWordsFound do begin
    StartTime;
    LexAnagramLetters := edAnagram.Text;
    EndTime;
    DisplayMessage(sbPage1, TimeElapsed(1));
    Clear;
    Sorted            := true;
    Items.BeginUpdate;
    ListIsAnagram     := false;
    try
      if (Pos(LexWildChar, edAnagram.Text) > 0) then
        Items.Assign(LexWordList)
      else begin
        ListIsAnagram := true;
        for lp1 := 0 to pred(LexWordList.Count) do begin
          LexWord := LexWordList[lp1];
          if (Length(LexWord) >= udAnagramNoChars.Position) then
            if (Length(LexWord) < 10) then
              Items.Add(' '+IntToStr(Length(LexWord)) + #9 + LexWord)
            else
              Items.Add(IntToStr(Length(LexWord)) + #9 + LexWord);
        end; {for}
      end; {if}
    except
    end; {try}
		TopIndex          := pred(Items.Count);
    Items.EndUpdate;
    pnNoItems.Caption := IntToStr(Items.Count);
  end; {with}
end; {edAnagramChange}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.edAnagramKeyPress(Sender : TObject; var Key : Char);
begin
  if not (key in Lexicon.LexCharSet) then begin
    case key of
      #8  : begin
            end;
      ' ' :	begin
              key := #0;
              SendMessage(edAnagram.Handle, WM_CHAR, Word(LexiconAnagram.LexWildChar), 0);
            end;
    else
      if (Key <> LexiconAnagram.LexWildChar) then
        key	:= #0;
    end; {case}
  end; {if}
end; {edAnagramKeyPress}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.udAnagramNoCharClick(Sender : TObject; Button : TUDBtnType);
var
  lp1     : integer;
  LexWord : shortstring;
begin
  pnAnagramNoChars.Caption  := IntToStr(udAnagramNoChars.Position);
  if ListIsAnagram then begin
    with LexiconAnagram, lbWordsFound do begin
      Items.BeginUpdate;
      Clear;
      Sorted  := true;
      try
        for lp1 := 0 to pred(LexWordList.Count) do begin
          LexWord := LexWordList[lp1];
          if (Length(LexWord) >= udAnagramNoChars.Position) then
            if (Length(LexWord) < 10) then
              Items.Add(' '+IntToStr(Length(LexWord)) + #9 + LexWord)
            else
              Items.Add(IntToStr(Length(LexWord)) + #9 + LexWord);
        end; {for}
      except
      end; {try}
		  TopIndex := pred(Items.Count);
      Items.EndUpdate;
      pnNoItems.Caption  := IntToStr(Items.Count);
    end; {with}
  end; {if}
end; {udAnagramNoCharsClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.DisplayStatistics;
var
  ch1 : char;
  lp1 : integer;
begin
  with Lexicon, LexStatistics do begin
    LexGetStatistics;
    lbInitialLetters.Clear;
    for lp1 := 1 to Length(LexInitialLetters) do begin
      ch1 := LexInitialLetters[lp1];
      lbInitialLetters.Items.Add(ch1 + #9 + IntToStr(InitialLetterCount[ch1]));
    end; {for}
    pnTotalCount.Caption  := IntToStr(LexWordCount);
    lbWordLength.Clear;
    for lp1 := MinLengthWord to MaxLengthWord do
      if (WordLengthCount[lp1] > 0) then begin
        if (lp1 < 10) then
          lbWordLength.Items.Add(' '+IntToStr(lp1) + #9 + IntToStr(WordLengthCount[lp1]))
        else
          lbWordLength.Items.Add(IntToStr(lp1) + #9 + IntToStr(WordLengthCount[lp1]));
      end; {if}
  end; {with}
end; {DisplayStatistics}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.lbWordsFoundDblClick(Sender : TObject);
var
  LexWord : shortstring;
begin
  Screen.Cursor := crHourGlass;
  with Lexicon, lbWordsFound do begin
    LexWord := Items[ItemIndex];
    if LexWordDelete(LexWord) then begin
      Items.Delete(ItemIndex);
      DisplayStatistics;
      DisplayMessage(sbPage1, LexWord + ' - deleted');
      pnNoItems.Caption := IntToStr(StrToInt(pnNoItems.Caption)-1);
    end; {if}
  end; {with}
  Screen.Cursor := crDefault;
end; {lbWordsFoundDblClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.edAnagramDblClick(Sender : TObject);
var
  lp1 : integer;
begin
  with Lexicon, lbWordsFound do
    if LexWordAdd(edAnagram.Text) then begin
      LexiconTools.LexWordGetList(edAnagram.Text[1], 0, 0);
      with lbWordsFound do begin
        try
          Items.Assign(LexiconTools.LexWordList);
        except
        end; {try}
     	  lp1	:= 0;
     	  while (lp1 < pred(Items.Count)) and (Items[lp1] <> edAnagram.Text) do
				  inc(lp1);
        if (Items[lp1] = edAnagram.Text) then
          TopIndex	:= lp1;
      end; {with}
      pnNoItems.Caption := IntToStr(LexiconTools.LexWordList.Count);
      DisplayStatistics;
    end; {if}
end; {edAnagramDblClick}

{--------------------------------------------------------------------------------------------------}
{                                      EXAMPLE2 PAGE                                               }
{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.UpdateCompressPercent(Percent : integer);
begin
  pbCompress.Visible  := (Percent > 0);
  pbCompress.Position := Percent;
  with LexiconFileTools.LexCompressInfo do begin
    lbTotWordCount.Caption  :=  IntToStr(TotWordCount);
    lbLexWordCount.Caption  :=  IntToStr(LexWordCount);
    lbErrDupWCount.Caption  :=  IntToStr(ErrDupWCount);
    lbErrCharCount.Caption  :=  IntToStr(ErrCharCount);
    lbErrLengCount.Caption  :=  IntToStr(ErrLengCount);
  end; {with}
  Application.ProcessMessages;
end; {UpdateCompressPercent}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.udCompressMinClick(Sender : TObject; Button : TUDBtnType);
begin
  with udCompressMin do begin
    pnCompressMin.Caption := IntToStr(Position);
    if (Position > udCompressMax.Position) then begin
      udCompressMax.Position  := Position;
      pnCompressMax.Caption   := IntToStr(Position);
    end; {if}
  end; {with}
end; {udCompressMinClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.udCompressMaxClick(Sender : TObject; Button : TUDBtnType);
begin
  with udCompressMax do begin
    pnCompressMax.Caption := IntToStr(Position);
    if (Position < udCompressMin.Position) then begin
      udCompressMin.Position  := Position;
      pnCompressMin.Caption   := IntToStr(Position);
    end; {if}
  end; {with}
end; {udCompressMaxClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btCompressClick(Sender : TObject);
var
  OpenDialog  : TOpenDialog;
  SaveDialog  : TSaveDialog;
begin
  OpenDialog  := TOpenDialog.Create(Self);
  with OpenDialog do begin
    Filter  := 'Text files (*.txt)|*.txt';
    Options := [ofFileMustExist, ofReadOnly, ofHideReadOnly, ofAllowMultiSelect];
    Title   := 'Select Lexicon Text Files';
  end; {with}
  SaveDialog  := TSaveDialog.Create(Self);
  with SaveDialog do begin
    DefaultExt  := 'lex';
    FileName    := 'Untitled.lex';
    Filter      := 'Lexicon files (*.lex)|*.lex';
    Options     := [ofOverwritePrompt, ofHideReadOnly, ofPathMustExist];
    Title       := 'Save Lexicon As';
  end; {with}
  with LexiconFileTools do begin
    try
      if OpenDialog.Execute then begin
        if SaveDialog.Execute then begin
          Update;
          Screen.Cursor         := crHourGlass;
          LexInputFileList      := OpenDialog.Files;
          LexOutputFileName     := SaveDialog.FileName;
          Lexicon.LexTitle      := edLexTitle.Text;
          Lexicon.LexCopyright  := edLexCopyright.Text;
          LexCompress(cbCompressCase.ItemIndex, udCompressMin.Position, udCompressMax.Position, cbLog.Checked);
          DisplayMessage(sbPage2, ExtractFileName(LexOutputFileName) + ' - Created');
          Screen.Cursor         := crDefault;
        end; {if}
      end; {if}
    finally
      OpenDialog.Free;
      SaveDialog.Free;
    end; {try}
  end; {with}
end; {btCompressClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btExpandClick(Sender : TObject);
var
  OpenDialog  : TOpenDialog;
  SaveDialog  : TSaveDialog;
begin
  OpenDialog  := TOpenDialog.Create(Self);
  with OpenDialog do begin
    Filter  := 'Lexicon files (*.lex)|*.lex';
    Options := [ofFileMustExist, ofReadOnly, ofHideReadOnly];
    Title   := 'Select Lexicon File';
  end; {with}
  SaveDialog  := TSaveDialog.Create(Self);
  with SaveDialog do begin
    DefaultExt  := 'txt';
    FileName    := 'Untitled.txt';
    Filter      := 'Text files (*.txt)|*.txt';
    Options     := [ofOverwritePrompt, ofHideReadOnly, ofPathMustExist];
    Title       := 'Save Lexicon Text File As';
  end; {with}
  with LexiconFileTools do begin
    try
      if OpenDialog.Execute then begin
        if SaveDialog.Execute then begin
          Update;
          LexInputFileList  := OpenDialog.Files;
          LexOutputFileName := SaveDialog.FileName;
          DisplayMessage(sbPage2, ExtractFileName(LexOutputFileName) + ' - ' + IntToStr(LexExpand) + ' Words');
        end; {if}
      end; {if}
    finally
      OpenDialog.Free;
      SaveDialog.Free;
    end; {try}
  end; {with}
end; {btExpandClick}

{--------------------------------------------------------------------------------------------------}
{                                      EXAMPLE3 PAGE                                               }
{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btFindClick(Sender : TObject);
var
  lp1 : integer;
begin
  if (edFind.Text <> '') then begin
    StartTime;
    for lp1 := 1 to 1000 do
      LexiconTools.LexWordExists(edFind.Text);
    EndTime;
    DisplayMessage(sbPage3, TimeElapsed(1000));
    if LexiconTools.LexWordExists(edFind.Text) then
      pnFindResult.Caption  := edFind.Text + ' - found'
    else
      pnFindResult.Caption  := edFind.Text + ' - not found';
  end; {if}
end; {btFindClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btAddWordClick(Sender : TObject);
var
  AddOK : boolean;
begin
  StartTime;
  AddOK := Lexicon.LexWordAdd(edFind.Text);
  if AddOK then
    pnFindResult.Caption  := edFind.Text + ' - added to lexicon'
  else
    pnFindResult.Caption  := edFind.Text + ' - error';
  EndTime;
  DisplayMessage(sbPage3, TimeElapsed(1));
  if AddOK then begin
    DisplayStatistics;
    LexiconTools.LexWordGetList(edFind.Text[1], 0, 0);
    try
      lbWordsFound.Items.Assign(LexiconTools.LexWordList);
    except
    end; {try}
    pnNoItems.Caption := IntToStr(LexiconTools.LexWordList.Count);
  end; {if}
end; {btAddWordClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btDeleteWordClick(Sender : TObject);
begin
  if (edFind.Text <> '') then begin
    StartTime;
    if Lexicon.LexWordDelete(edFind.Text) then
      pnFindResult.Caption  := edFind.Text + ' - deleted from lexicon'
    else
      pnFindResult.Caption  := edFind.Text + ' - not found in lexicon';
    EndTime;
    DisplayMessage(sbPage3, TimeElapsed(1));
    DisplayStatistics;
    LexiconTools.LexWordGetList(edFind.Text[1], 0, 0);
    try
      lbWordsFound.Items.Assign(LexiconTools.LexWordList);
    except
    end; {try}
    pnNoItems.Caption := IntToStr(LexiconTools.LexWordList.Count);
  end; {if}
end; {btDeleteWordClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.edPartialChange(Sender : TObject);
var
  lp1 : integer;
begin
  StartTime;
  for lp1 := 1 to 999 do
    LexiconTools.LexGetPartialWord(edPartial.Text);
  pnPartial.Caption := LexiconTools.LexGetPartialWord(edPartial.Text);
  EndTime;
  DisplayMessage(sbPage3, TimeElapsed(1000));
end; {edPartialChange}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btRandomClick(Sender : TObject);
begin
  Randomize;
  with Lexicon, LexiconTools do begin
    StartTime;
    pnRandom.Caption  := LexGetRandomWord(LexWildChar, 6, 9);
    EndTime;
    DisplayMessage(sbPage3, TimeElapsed(1));
  end; {with}
end; {btRandomClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btExpandMemClick(Sender : TObject);
begin
  StartTime;
  Lexicon.LexExpand;
  EndTime;
  DisplayMessage(sbPage3, TimeElapsed(1));
end; {btExpandMemClick}

{--------------------------------------------------------------------------------------------------}
{                                      EXAMPLE4 PAGE                                               }
{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btMonkeyClick(Sender : TObject);
var
  lp1, lp2  : integer;
  RndWord   : shortstring;
begin
  Screen.Cursor := crHourGlass;
  Randomize;
  with Lexicon, lbMonkey do begin
    Clear;
    Items.BeginUpdate;
    StartTime;
    for lp1 := 1 to 1000000 do begin
      RndWord[0]  := chr(Random(4)+6);
      for lp2 := 1 to Length(RndWord) do
        RndWord[lp2]  := LexInitialLetters[succ(Random(Length(LexInitialLetters)))];
      if LexiconTools.LexWordExists(RndWord) then
        Items.Add(RndWord);
    end; {for}
    EndTime;
    DisplayMessage(sbPage4, TimeElapsed(-1000000));
    Items.EndUpdate;
  end; {with}
  Screen.Cursor := crDefault;
end; {btMonkeyClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.btReadAllClick(Sender : TObject);
var
  lp1, lp2  : integer;
begin
  Screen.Cursor := crHourGlass;
  with Lexicon, LexiconTools do begin
    StartTime;
    for lp1 := 1 to Length(LexInitialLetters) do begin
      LexWordGetList(LexInitialLetters[lp1], 0, 0);
      for lp2 := 0 to pred(LexWordList.Count) do
        LexWordExists(LexWordList[lp2]);
    end; {for}
    EndTime;
    DisplayMessage(sbPage4, TimeElapsed(-LexWordCount));
  end; {with}
  Screen.Cursor := crDefault;
end; {btReadAllClick}

{--------------------------------------------------------------------------------------------------}

procedure TfrmWordMagic.edLexFitLineChange(Sender : TObject);
var
  lp1         : integer;
  TempString  : shortstring;
begin
  with LexiconGameLine do begin
    TempString  := '';
    for lp1 := 1 to Length(edLexLine.Text) do
      if (Pos(edLexLine.Text[lp1], Lexicon.LexInitialLetters) > 0) then
        TempString  := TempString + edLexLine.Text[lp1]
      else
        TempString  := TempString + LexEmpty;
    LexWordList.Clear;
    LexLetters  := edLexChars.Text;
    LexLine     := TempString;
    StartTime;
    for lp1 := 1 to pred(Length(edLexLine.Text)) do
      LexLinePos  := lp1;
    try
      lbLexLineWords.Items.Assign(LexWordList);
    except
    end; {try}
    EndTime;
    DisplayMessage(sbPage4, TimeElapsed(1));
  end; {with}
end; {edLexFitLineChange}

{--------------------------------------------------------------------------------------------------}

{ObjWordMagic}
end.
